Bug 1371433 - [RFE] Directly instruct NM to avoid controlling and monitoring a device.
Summary: [RFE] Directly instruct NM to avoid controlling and monitoring a device.
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: NetworkManager
Version: 7.2
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: rc
: ---
Assignee: Thomas Haller
QA Contact: Desktop QE
URL:
Whiteboard:
Depends On:
Blocks: 1393481 1428418
TreeView+ depends on / blocked
 
Reported: 2016-08-30 08:22 UTC by Edward Haas
Modified: 2017-08-01 09:17 UTC (History)
14 users (show)

Fixed In Version: NetworkManager-1.8.0-0.4.rc3.el7
Doc Type: Enhancement
Doc Text:
Clone Of:
: 1428418 (view as bug list)
Environment:
Last Closed: 2017-08-01 09:17:07 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:2299 normal SHIPPED_LIVE Moderate: NetworkManager and libnl3 security, bug fix and enhancement update 2017-08-01 12:40:28 UTC

Description Edward Haas 2016-08-30 08:22:38 UTC
Description of problem:
When using other network controllers on a host, it is required to transfer ownership of certain devices from NM.

Currently, this is possible by editing ifcfg device files with the NM_CONTROLLED key.
Unfortunately this is not sufficient for several reasons, most outstanding one is when the network controller is not using ifcfg files for managing its devices.

A direct API/Command is required to instruct NM to release ownership from a device, persistently and without a dependency on ifcfg initscripts.

This RFE is triggered by the need of RHV host agent (VDSM) to operate in conjunction with NetworkManager, each owning their own devices and not interfering with each other.

Comment 2 Thomas Haller 2016-08-30 13:15:13 UTC
Is this for devices that are initially setup by NetworkManager but then NM should let them go and not touch them anymore?

Can you elaborate on that usecase? Note that device which use (say) DHCP need something to babysit the address leases. How is that supposed to work with NetwokrManager stopping to care about the device?

Comment 3 Edward Haas 2016-08-30 13:59:23 UTC
(In reply to Thomas Haller from comment #2)
> Is this for devices that are initially setup by NetworkManager but then NM
> should let them go and not touch them anymore?

Yes
> 
> Can you elaborate on that usecase? Note that device which use (say) DHCP
> need something to babysit the address leases. How is that supposed to work
> with NetwokrManager stopping to care about the device?

Any subsequent implications of taking the device ownership is up to the controller that has requested it.
In a simplistic manner, the controller will just define everything from scratch on the device through whichever means it wants (ifcfg, iproute2, netlink).

From the NM side, it should try to gracefully cleanup when releasing ownership: In the DHCP case, I guess this involves taking down the dhclient that it spawned or deamonizing that run (if it is not yet so).
IMO, killing the dhclient is enough.
But it should better not flush existing addresses and other settings.

The simplest usecase I can think of is this:
- Host networking settings are defined by NM.
- Install a controller.
- Controller is issued a command to use several devices:
  - Reads current kernel configuration.
  - Instructs NM to release ownership of the devices.
  - Check that NM is not owning it (in case the previous is not blocking)
  - Controller configures the devices as instructed and owns them.
- Controller can return ownership to NM and configure the connection.

Comment 4 Thomas Haller 2017-04-18 13:11:03 UTC
please review th/device-release-rh1371433

Comment 5 Francesco Giudici 2017-04-18 16:37:38 UTC
lgtm

Comment 7 errata-xmlrpc 2017-08-01 09:17:07 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2017:2299


Note You need to log in before you can comment on or make changes to this bug.